Option Explicit
'------------------------------------------------------------
'This sample application demonstrates general procedures for
'installing and maintaining an icon in the Win95 toolbar tray
'from a VB3 program using CALL32.DLL to thunk the
'necessary 32-bit calls.  Requires that CALL32.DLL be present
'in order to work properly.  Written 8/95 by Don Bradner and
'placed in the public domain.  Comments welcome to the author at
'Compuserve 76130,1007 or in the CIS VBPJ Forum.  The author may
'also be contacted as dbirdman@redshift.com
'Modified 9/95 to include MsgHook.VBX for callbacks.
'-------------------------------------------------------------------

' -----------------------------------------------------------
' NOTIFYICONDATA type is needed for Shell_NotifyIcon function
'------------------------------------------------------------
Type NOTIFYICONDATA
    lStructureSize    As Long
    hWnd   As Long
    lID As Long
    lFlags As Long
    lCallBackMessage As Long
    hIcon As Long
    sTip As String * 64
End Type

Type lRect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Type APPBARDATA
    lStructureSize As Long
    hWnd As Long
    lCallBackMessage As Long
    lEdge As Long
    rc As lRect
    lParam As Long
End Type

'----------------------------------------------------------------------
'The OsVersionInfo structure is used by the 32-bit GetVersionEx Function
'----------------------------------------------------------------------

Type OsVersionInfo
    dwVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatform As Long
    szCSDVersion As String * 128
End Type

' --------------------------------------------------------
' Declare32 is a general function required for call32.dll use
' --------------------------------------------------------
Declare Function Declare32& Lib "call32.dll" (ByVal func$, ByVal library$, ByVal args$)


' --------------------------------------------------------
' 32-bit registry functions in Call32 format:
' --------------------------------------------------------
Declare Function Shell_NotifyIcon& Lib "call32.DLL" Alias "call32" (ByVal lMessage&, NID As NOTIFYICONDATA, ByVal id&)
Declare Function SHAppBarMessage& Lib "call32.DLL" Alias "call32" (ByVal dwMessage&, pData As APPBARDATA, ByVal id&)
Declare Function GetVersionEx& Lib "call32.dll" Alias "call32" (lpStruct As OsVersionInfo, ByVal id&)

' --------------------------------------------------------
' Functions to determine what Windows we are running
' --------------------------------------------------------
Declare Function GetWinFlags& Lib "Kernel" ()
Declare Function GetVersion& Lib "Kernel" ()

Global idShell_NotifyIcon&
Global idSHAppBarMessage&
Dim idGetVersionEx&
Dim OsVers As OsVersionInfo

Global Const NIM_ADD = 0&
Global Const NIM_DELETE = 2&
Global Const NIM_MODIFY = 1&
Global Const NIF_ICON = 2&
Global Const NIF_MESSAGE = 1&
Global Const NIF_TIP = 4&

Global Const ABM_GETTASKBARPOS = &H5&

Global structNotify As NOTIFYICONDATA
Global structBarData As APPBARDATA
Global lTemplong&

' --------------------------------------------------------
' Used with GetVersion and GetWinFlags
' --------------------------------------------------------
Global Const WF_WINNT = &H4000&
Global Const WinNT = 3
Global Const Win32 = 2
Global Const win16 = 1
Global iWinVers%

'----------------------------------------------------------
'This sample application implements callbacks via the MsgHook
'message handling control.  Windows will generate a User
'Message with an lParam that identifies a mouse event, such
'as WM_MOUSEMOVE, and the wParam will contain the icon number.
'If the application installs more than one icon, each must be
'given a unique ID number.
'-----------------------------------------------------------

Const WM_USER = &H400
Global Const UM_TASKBARMESSAGE = WM_USER + &H201

'-----------------------------------------------------------
'The 10 available mouse events:
'-----------------------------------------------------------

Global Const WM_MOUSEMOVE = &H200
Global Const WM_LBUTTONDOWN = &H201
Global Const WM_LBUTTONUP = &H202
Global Const WM_LBUTTONDBLCLK = &H203
Global Const WM_RBUTTONDOWN = &H204
Global Const WM_RBUTTONUP = &H205
Global Const WM_RBUTTONDBLCLK = &H206
Global Const WM_MBUTTONDOWN = &H207
Global Const WM_MBUTTONUP = &H208
Global Const WM_MBUTTONDBLCLK = &H209

Function GetVersion32% ()
    idGetVersionEx = Declare32("GetVersionEx", "kernel32", "p")
    OsVers.dwVersionInfoSize = 148&
    lTemplong = GetVersionEx(OsVers, idGetVersionEx)
    GetVersion32 = OsVers.dwMajorVersion * 100 + OsVers.dwMinorVersion
End Function

